public class Model {
	Point center;
	PointList points;
	PolyList polygons;
	boolean abs = false;
	//-----------------------------------------
	//constructor
	//-----------------------------------------
	public Model() {
		this.center = new Point();
		this.points = new PointList();
		this.polygons = new PolyList();
	}
	public Model(int numpoint, int numpoly) {
		this.center = new Point();
		this.points = new PointList(numpoint);
		this.polygons = new PolyList(numpoly);
	}
	//----------------------------------------
	//opperation
	//----------------------------------------
	public void move(double x, double y, double z){
		if (this.abs == true) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].add(x,y,z);
			}
		}
		center.add(x,y,z);
	}
	public void rotate_x(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_x(r);
		}
	}
	public void rotate_y(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_y(r);
		}
	}
	public void rotate_z(double r) {
		for (int i = 0; i<this.points.num; i++) {
			this.points.list[i].rotate_z(r);
		}
	}
	//-------------------------------------------
	//compositor
	//-------------------------------------------
	public void absolute() {
		//point + vector
		if (this.abs == false) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].add(this.center);
			}
			this.abs = true;
		}
	}
	public void relative() {
		//point - vector
		if (this.abs == true) {
			for (int i = 0; i<this.points.num; i++) {
				this.points.list[i].sub(this.center);
			}
			this.abs = false;
		}
	}
	//-------------------------------------------
	//compositor
	//-------------------------------------------
	public void compose(String str) {
			String[] polys = str.split("\n");				//extract polygon from string (separated by newline)
			for (int i=0; i<polys.length; i++) {
				String[] points = polys[i].split(" ");		//extract point from polygon string (sparated by whitespace)
				Poly poly = new Poly(points.length);
				for (int j = 0; j<points.length; j++) {
					String[] comps = points[j].split(":");	//extract x,y,z from point string (separated by : like x:y:z) 
					double x = Double.parseDouble(comps[0]);
					double y = Double.parseDouble(comps[1]);
					double z = Double.parseDouble(comps[2]);
					//if it is the first trio , then it is the color
					if (j == 0) {
						poly.fill((int)(x*255),(int)(y*255),(int)(z*255));
					}
					else if (j == 1) {
						poly.draw((int)(x*255),(int)(y*255),(int)(z*255));
					}
					else {
						//add point only if not already in list
						int point = -1;
						for (int h = 0; h < this.points.num; h++) {
							if ( (this.points.list[h].x == x)&&(this.points.list[h].y == y)&&(this.points.list[h].z == z) ) {
								point = h;
							}
						}//because many polygons can share the same point
						if (point == -1) {
							point = this.points.append(new Point(x,y,z));	//return point number in the points.list[]
						}
						//the second argument is not to plug but the face vector
						//still on the point list, but un connected with other in polygon
						//polygon keep it in face argument, use it for back face culling
						if (point != -1) {
							poly.append(point);		//need point number as argument
						}
					}
				}
				this.polygons.append(poly);
			}
	}
}
